 /*
Software  WiFi ESP Chip OTA & WifiSetup
 
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

Wifi setup code is based on the code of nikant at https://github.com/nikant/espWiFi2eeprom
Also code is based on https://github.com/esp8266/Arduino
 
modified by TomT
contact : info@tomz.ws
 
First Revision ALPHA 1
  */
  
  /*
  * Default SoftAP IP is : 192.168.4.1
  * Default SoftAP Port is : 80
  * Default SoftAP Password is : esp8266-1
  * 
  * COM Port : 115200 Baud 8N1
  */

/* 
 *  ########## Pins ############
 *  GPIO5 = OUTPUT
 *  
 *  
 */


   /*
    * ################ READ ME BEFORE ######################
    * 
    *  Please use the foloowing settings to flash the program:
    *  * ##### programming settings for ARDUINO #####
    *  Board : generic ESP8266 Module
    *  Flash Mode : DIO
    *  Flash Size : 4M (1M SPIFFS)   CHECK WHAT ESP YOU GOT MAYBE 1M (64k SPIFFS)
    *  Debug Port : disabled
    *  Debug Level : none
    *  Reset Method : ck
    *  Crystal frequency : 26 MHz 
    *  Flash frequency : 40 MHz 
    *  CPU frequency : 80 MHz 
    *  Upload Speed : 115200
    *  
    *  After flash is done, you can remove the Plug from your computer USB UART Connection.
    *  Power the system!
    *  
    *  Look for a Wifi Access point called somewhat like ESP_XYZ
    *  Make a connection to this Access Point and type into your browser
    *  192.168.4.1.
    *  You will see a page where you can choose your Homenetwork.
    *  Type in the Name and SSID Password and after that reboot the ESP.
    *  
    *  Then it will login into your local network and you now need to find the correct IP Adress.
    *  Type in the IP Adress and a page will be shown, wehere you can configure and Switch ON / OFF the Obi Plug.
    *  
    *  In future i will add functions.
    *  The OTA Over the air Update is integrated and you can updtae to a new Firmware version without opening the Plug again. 
    *  
    *  DISCLAIMER / WARRANTY:
    *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
    *  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, 
    *  TITLE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING 
    *  THE SOFTWARE BE LIABLE FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, 
    *  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE 
    *  OR OTHER DEALINGS IN THE SOFTWARE.
    *  
    *  USE ANYTHING HERE AT YOUR OWN RISK....
    *  
    * 
    * #########################################################
   */

/*
 * DON'T CHANGE ANYTHING BELOW!
 * EVERYTHING WILL BE CONBFIGURED LATER WITH YOUR WEBBROWSER 
*/


#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>
#include <WiFiClient.h>
#include <ESP8266mDNS.h>
#include <ESP8266HTTPUpdateServer.h>



   
//System  **** DONT CHANGE THIS or system will fail to run ****
const String VERSION = "1.0.1 ALPHA";        //Thats the actual Version of FW
String wwwInfos = "";                        //will be filled in later with actual data

String wwwStatus = "";                       //takes the last Status message
String wwwStatus1 = "";                       //takes the last Status message
String wwwStatus2 = "";                       //takes the last Status message
String wwwStatus3 = "";                       //takes the last Status message
String wwwStatus4 = "";                       //takes the last Status message

String wwwGoBack = "";                       //holds the code for the back to root button 

unsigned long timeNow = 0;                   //timestamp for timeroperations / msec.
unsigned long dKeepWIFIAlive = 900 * 1000;   //15min. --- time for Reconnect loop every x msec.
unsigned long lKeepWIFIAlive = 0;            //timestamp of last Reconnect / msec.


ESP8266WebServer server(80);
ESP8266HTTPUpdateServer httpUpdater;


// We create a Timestamp
String timeStamp() { 
      char stamp[10];
      unsigned long tHour = millis()/3600000;
      unsigned long tMinute = millis()/60000-tHour*60;
      unsigned long  tSecond = millis()/1000-tHour*3600-tMinute*60;
      sprintf (stamp,"%03d:%02d:%02d", tHour, tMinute, tSecond);
      return stamp;
}



String wwwHeader = "<!DOCTYPE HTML>\n"
                  "<html><head><meta content=\"text/html;charset=utf-8\"><title>ESP8266 TITLE GOES HERE</title>\n"
                  "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">"
                  "<style type=\"text/css\">body {text-align:center;font-family: sans-serif;background-color: #000000;color: #AAAAAA;font-size:0.9em;} a:link, a:visited, a:hover, a:active {color:#fffff;}</style>"
                  "</head>\n"
                  "<body>\n"
                  "<center>\n"
                  "<table border=1 width=\"80%\" cellpadding=\"6\"><tr><td colspan=2>"
                  "<h2>ESP8266 NAME GOES HERE</h2>"
                  "</td></tr>\n\n";


String wwwFooter =  "</table><br><hr>\n"
                   "<p style=\"font-size:0.6em\" a:link, a:visited, a:hover, a:active {color:#fffff;>2017 by TomT - - - Version " + VERSION + " - - - contact me : <a href=\"http://www.tomz.ws\" target=_new>http://www.tomz.ws</a> or send email to : <a href=\"mailto:info@tomz.ws\">info@tomz.ws</a><br>"
                   "AP for WIFI settings is found at 192.168.4.1, if the ESP is not connected to a network. "
                    "If ESP fails to connect to a network, it will start an AP after 60 sec. timeout<br></p></center>\n"
                   "</body></html>";




String wwwCommandlist = "<tr><td colspan=2><b>Commands for setup :</b></td></tr><tr><td valign=top>\n"
                        "<p style=\"font-size:0.8em\">"
                        "<br>"
                        "<b><a href=/reboot title=\"restart the ESP\">[REBOOT]</a> : </b>\n"
                        "<b><a href=/erasessid title=\"clear the SSID and PASSWORD, reboot and open an AP for config\">[ERASE SSID]</a> : </b>\n"
                        "<b><a href=/eraseEEPROM title=\"clear the whole EEPROM, reboot and open an AP for config\">[ERASE EEPROM]</a> : </b> \n"
                        "<b><a href=/update title=\"Update Firmware OverTheAir\">[FIRMWARE UPDATE]</a></b><br><br>\n"
                        "</p><br>\n"
                        "</td><td>New col</td></tr>\n";

                        

void handle_root() {
  wwwInfos = "<tr><td><b>ESP8266</b><br><br> own IP : " + WiFi.localIP().toString() + "<br>";
  wwwInfos = wwwInfos + "GATEWAY : " + WiFi.SSID() +"<br>";
  wwwInfos = wwwInfos + "IP : " + WiFi.gatewayIP().toString()  + "<br>";
  wwwInfos = wwwInfos + "RSSI : " + WiFi.RSSI() + " dBm<br>";
  wwwInfos = wwwInfos + "FlashSize : " + ESP.getFlashChipSize() + "<br>";
  wwwInfos = wwwInfos + "Time since start : " + timeStamp() + "<br><br>";
  //wwwInfos = wwwInfos + "<a href=/..>Do Something here</a><br><br>";
  wwwInfos = wwwInfos + "</td>";
  wwwInfos = wwwInfos + "<td><p style=\"font-size:0.8em\"><b>SETTINGS :</b></p><br>";
  wwwInfos = wwwInfos + "</td></tr>";
  wwwInfos = wwwInfos + "<tr><td colspan=2><p style=\"font-size:0.8em\">Last Status : " + wwwStatus + "</p></td></tr>";
  server.send(200, "text/html", wwwHeader + wwwInfos + wwwCommandlist + wwwFooter);
  delay(100);
}



void setup() {

  Serial.begin (115200);
  WiFi.persistent(false);  // set WiFi credentials persistance to false to prevent eeprom corruption
  WiFi.setOutputPower(20.5);
  WiFi.mode(WIFI_STA);
  espNKWiFiconnect();
  
  char host[32];
  String tmpValue = WiFi.SSID();
  tmpValue.toCharArray(host, 32);
  
  MDNS.begin(host);

  Serial.println("IP address: "+ WiFi.localIP().toString());

  server.on("/", handle_root);
  server.on("/reboot", handle_APrestart);
  server.on("/erasessid", handle_clearAPeeprom);
  server.on("/eraseEEPROM", handle_clearAPalleeprom);
  
  //server.on("/CALL", functionName);



  httpUpdater.setup(&server);
  server.begin();
  Serial.println("HTTP server started");
  build_wwwStatus("HTTP server started");
  
  MDNS.addService("http", "tcp", 80);

  timeNow = millis();
  lKeepWIFIAlive = millis();

 
  //set the Pins to input or output mode 
  pinMode(5, OUTPUT);  

  setInitialState();
  URL_GoBack();
}


void loop() {
  
  timeNow = millis();
  server.handleClient();
  delay(10);


   // Should that be a fix of Connection fails to the webserver?
   // we give it a try
   // see https://github.com/esp8266/Arduino/issues/2330
   //or use ping script that pings the ESP every 30 sec. (CuxD Ping device) 
   // we test with 2 minutes
   // 30sec Test was ok
   if (timeNow - lKeepWIFIAlive > dKeepWIFIAlive) {
     WiFi.reconnect();
     lKeepWIFIAlive = timeNow;
     delay(10);
   }

}


//switch Relay ON
void Function(){
    // Commands
    delay(50); 
    String eAnswer = server.arg("CALL");
    server.send(200, F("text/html; charset=utf-8"), "What you gonna have to say "  + wwwGoBack);
     delay(100); 
}




/* set the initial States
 * needed on future Options configured by the user
 * 
*/
void   setInitialState() {
    // default should be .....
    
    //Function CALL HERE();
       
}

void URL_GoBack() {
  wwwGoBack = "<br><a href=\"/\" target=\"_self\">OK - GO BACK</a>";
}


void build_wwwStatus(String S) {
  // call with a message 
  //build_wwwStatus("StatusMessage");

  wwwStatus4 = wwwStatus3; 
  wwwStatus3 = wwwStatus2; 
  wwwStatus2 = wwwStatus1;
  wwwStatus1 = timeStamp() + " " + S;

  wwwStatus = wwwStatus1 + " / " + wwwStatus2 + " / " + wwwStatus3 + " / " + wwwStatus4;
  
}

